%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Main Menu
% 9 November 2006, Release 0.85
%
% Input:
%
% Output:
%
% Internal Variables:
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all; close all; clc

load xtrain
p=audioplayer(y, Fs);
play(p)

disp('*** Version Release 0.85 - This is Draft Code and is NOT to be Used for Proposal Analysis ***')
disp('Known problems for this 9 November 2006 release:')
disp('  1. S-V parametric parameters are known to be incomplete for some of the channel models')
disp('  2. Impulse responses have not been verified by the committee')
disp('  3. Comments & documentation throughout the code is incomplete')
disp('  4. There are several MATLAB warnings which I need to resolve')
disp('  5. I can not gurarantee that the code will not crash for this release')
disp('     [note: if possible, please send me the CM cluster files that crashed]')
disp(' ')

while 1

    disp('Main Menu for 802.15.3c Channel Model ...')
    disp(' Option 1: Analyze Statistics of a Previously Generated CM Impulse Response & View Realizations')
    disp(' Option 2: Generate CM Impulse Responses by Appling Spatial Filtering & Entering Sample Rate')
    disp(' Option 3: Obtain Cluster Statistics')
    disp(' Option 4: Graphically View S-V Clusters for a Particular CM')
    disp(' Option 5: Generate All New S-V Clusters')
    disp(' Option 6: Load S-V Parameters and Make Directories')
    disp(' Option 7: Exit Program')

    pause(0.8); disp(' ')
    
OptNum = -1; % initialize to illegal value
while (OptNum>7 || OptNum<1)
    OptNum = input('Input Menu Option Number [1, 2, 3, 4, 5, 6, 7] ');
end

if OptNum==1 || OptNum==2 || OptNum==3 || OptNum==4
    disp(' ')
    disp('Please Enter Channel Model Number of Interest')
    ChanNum = -1; % initialize to illegal value
    while (ChanNum>10 || ChanNum<1)
        ChanNum = input('Please Input CM Number: (1.1, 1.2, 1.3, 1.4, 1.5, 2, 3.1, 3.2, 4, 5, 6, 7, 8, 9.1, 9.2, 9.3, 10) ');
    end
    save ChanNum ChanNum
end

switch OptNum
    
    case(1)
        disp(' ');disp('Warning: you must generate an impulse response, via menu option 2, before you can analyze it.')
        disp('If the program crashes at this point, it is probably because the impulse response has not been generated.')
        AnalyzeImpulse; % call Analyze Impulse
        
    case(2)
        GenImpulse; % call Generate Impulse
        
    case(3)
        ClusterStats; % call Cluster Statistics

    case(4)
        ViewClusters; % call View S-V Clusters
        
    case(5)
        load xgong
        p=audioplayer(y, Fs);
        play(p)

        display('  Caution: proceeding will overwrite previously stored clusters!')
        CautionQuestion = -1; % initialize to illegal value
        while (CautionQuestion>2 || CautionQuestion<1)
            CautionQuestion = input('   Do you want to proceed? [1="yes", 2="no"] ');
        end
        
        switch CautionQuestion
            
            case(1)
                LoadParams; % first load and store the parameters as defined by TG3c
                GenClusters; % call Generate Clusters
                
            case(2)
                display('   *** Terminating Program ***')
                
        end

    case(6)
        
        LoadParams; % call Load S-V Parameters
        disp('*** MAKING DIRECTORIES - THEY MAKE ALREADY EXIST ***')
        
        % directory list ...
        % this list needs to reflect the CM numbers shown above
        mkdir('CM1.1'); mkdir('CM1.2'); mkdir('CM1.3'); mkdir('CM1.4'); mkdir('CM1.5'); mkdir('CM2'); mkdir('CM3.1'); mkdir('CM3.2')
        mkdir('CM4'); mkdir('CM5'); mkdir('CM6'); mkdir('CM7'); mkdir('CM8'); mkdir('CM9.1'); mkdir('CM9.2'); mkdir('CM9.3'); mkdir('CM10')
        
    case(7)
        load xhandel;
        p = audioplayer(y, Fs); 
        play(p, [1 (get(p, 'SampleRate') * 4.5)]);
        break

end

beep
disp(' '); disp('*** Strike Any Key to Continue ***')
pause
clear all; close all; clc; beep

end

disp(' ');disp('ALL DONE'); disp(' '); beep