%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Continuous Time to Discrete Time
% 9 November 2006, Release 0.85
%
% This routine converts cntinuous time to discrete time
%
% Input:
% 
% Output:
% 
% Internal Variables:
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [h_dt] = ct2dt( h_ct, t, num_channels, ts )

MaxTimeIndex=ceil(max(max(t))*1e-9/ts);
MaxTime=MaxTimeIndex*ts;

h_dt=zeros(MaxTimeIndex,num_channels);

for ChanIndex=1:num_channels
    for RayIndex=1:length(t(:,1))
        TimeBin=floor(MaxTimeIndex*(t(RayIndex,ChanIndex)*ts)/MaxTime);
        h_dt(TimeBin+1,ChanIndex)=h_dt(TimeBin+1,ChanIndex)+h_ct(RayIndex,ChanIndex);
    end
end
